KillingBlowAnnouncer = LibStub("AceAddon-3.0"):NewAddon("KillingBlowAnnouncer", "AceConsole-3.0", "AceEvent-3.0")

local options = {
	name = "KillingBlowAnnouncer",
	handler = KillingBlowAnnouncer,
	type = 'group',
	args = {
				Options= {
					name		=	"Message",
					type		=	"group",
					guiInline	=	true,
					order		=	1,
					args		=	{		
								enablingMSG		=	{
									type		=	"toggle",
									name		=	"Enable /say Message",
									desc		=	"Enables the Killing blow /say message ",						
									get			=	"EnableMSG",
									set			=	"ToggleEnableMSG",
									},
								
							    msg = {
									type = "input",
									name = "KB Message",
									desc = "The /say message displayed when you get a KB",
									usage = "<Your message here>",
									get = "GetMessage",
									set = "SetMessage",
								},
							 	
								},
						},
			Options2= {
					name		=	"Tracker",
					type		=	"group",
					guiInline	=	true,
					order		=	2,
					args		=	{		
								enablingMSG2		=	{
									type		=	"toggle",
									name		=	"Enable KBtracker",
									desc		=	"Enables the Killing blow tracker frame",						
									get			=	"EnableKBT",
									set			=	"ToggleEnableKBT",
									},
								},
						},
			Header1= {
					type		=	"header",
					order		=	3,
					name		=	"",
				},
				
			},			
	
}



local defaults = {
    profile = {
		enableMSG= true,
		enableKBT= true,
		message = "default",
    },
}

function KillingBlowAnnouncer:OnInitialize()
	KillingBlowAnnouncer:RegisterChatCommand("kba", "KillingBlowAnnouncerSlash")
	
	self.db = LibStub("AceDB-3.0"):New("kbaDB", defaults, "Default")	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("KillingBlowAnnouncer", options)		
	self.KillingBlowAnnouncerOptions = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("KillingBlowAnnouncer", "KillingBlowAnnouncer")
end

KillingBlowAnnouncer.enableMSG = true;
KillingBlowAnnouncer.enableKBT = true;

function KillingBlowAnnouncer:EnableMSG(info)
    return self.db.profile.enableMSG
end

function KillingBlowAnnouncer:ToggleEnableMSG(info, value)
    self.db.profile.enableMSG = value	
end

function KillingBlowAnnouncer:EnableKBT(info)
    return self.db.profile.EnableKBT
end

function KillingBlowAnnouncer:ToggleEnableKBT(info, value)
    self.db.profile.EnableKBT = value	
end

function KillingBlowAnnouncer:GetMessage(info)
    return self.db.profile.message
end

function KillingBlowAnnouncer:SetMessage(info, newValue)
    self.db.profile.message = newValue
end

	


-- Add a function to the /KillingBlowAnnouncer slash command.
function KillingBlowAnnouncer:KillingBlowAnnouncerSlash(input)
	InterfaceOptionsFrame_OpenToCategory("KillingBlowAnnouncer")
	InterfaceOptionsFrame_OpenToCategory("KillingBlowAnnouncer")
end

-- Frame for killing blow message
local fStart = CreateFrame("Frame")
local kbs_session = 0;
local kbs_bg = 0;
fStart:RegisterEvent("PLAYER_LOGIN");

local function eventHandler(self, event, ...)
	print("|cffffff00Killing Blow Announcer|r|cff00E5EE v1.03");

	
	message = CreateFrame("MessageFrame", "KBFrame", UIParent)
	message:SetPoint("LEFT")
	message:SetPoint("RIGHT")
	message:SetPoint("CENTER")
	message:SetHeight(31)
	message:SetInsertMode("TOP")
	message:SetFrameStrata("HIGH")
	message:SetTimeVisible(3)
	message:SetFadeDuration(1)
	message:SetFont(STANDARD_TEXT_FONT, 30, "OUTLINE")



end
fStart:SetScript("OnEvent", eventHandler);



-- Announcing of the killing blows
local function OnEvent(self, event, timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, ...)
	local spellID, spellName, spellSchool, amount, overkill
	local playerName = UnitName("player");
	local petName = UnitName("pet");
	frame_hide();	

			if (subevent == "PARTY_KILL") and (sourceName == playerName or sourceName == petName)  and (destFlags == 66888) 
				then			
					message:AddMessage("KILLING BLOW!", 1, 1, 0)	
					tracker_update();
				if (KillingBlowAnnouncer:EnableMSG(info) == true) then
					SendChatMessage(KillingBlowAnnouncer:GetMessage(info),"Say");
				end			
		end		
end



-- Killing blow frame
local f = CreateFrame("Frame")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:SetScript("onEvent", OnEvent)




-- The following code is for the KB tracker
local backdrop = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		tile = false,   
		tileSize = 32,  
		edgeSize = 10, 
		insets = {   
			left = 0,
			right = 0,
			top = 0,
			bottom = 0
		}
	}   
	





-- Creating kbtracker frame	
local frame = CreateFrame("Frame", "DragFrame2", UIParent)
	  frame:SetMovable(true)
	  frame:EnableMouse(true)
	  frame:RegisterForDrag("LeftButton")
	  frame:SetScript("OnDragStart", frame.StartMoving)
	  frame:SetScript("OnDragStop", frame.StopMovingOrSizing)

      frame:SetPoint("CENTER")
	  frame:SetSize(95, 64)
	  frame:SetBackdrop(backdrop);

	  frametext =  frame:CreateFontString("frametext" ,"ARTWORK","GameFontNormal");
      frametext:SetPoint("TopLeft", frame, "TopLeft", 5, -8)
	  frametext:SetText("    |cFFFFFFFF   KBs:\n" .. "|cffffcc00Active BG: ".. kbs_bg .."\n" .. "Session:     ".. kbs_session)
	  frametext:SetJustifyH("left")





-- function for hiding and showing of the frame
local event_hide = CreateFrame("Frame")   
event_hide:RegisterEvent("CHAT_MSG_CHANNEL") 

event_hide:SetScript("OnEvent",
    function(self, event, addon)
		frame_hide()
end) 



function frame_hide()	
	if (KillingBlowAnnouncer:EnableKBT(info) == false) then
			frame:Hide();
	else 
			frame:Show();
	end
	
end
 


-- function for updating the frame
function tracker_update()
	local score = GetNumBattlefieldScores();			
	local playerName = UnitName("player");
	local petName = UnitName("pet");
	local pvpType, isFFA, faction = GetZonePVPInfo();
	
	if pvpType == "contested" then
		kbs_bg = kbs_bg + 1;
	end
	
	kbs_session = kbs_session + 1;
	frametext:SetText("    |cFFFFFFFF   KBs:\n" .. "|cffffcc00Active BG: ".. kbs_bg .."\n" .. "Session:     ".. kbs_session)
		
end

	
local event_BGreset = CreateFrame("Frame") 
event_BGreset:RegisterEvent("UPDATE_BATTLEFIELD_STATUS") 

event_BGreset:SetScript("OnEvent",
    function(self, event, addon)	
		kbs_bg = 0;	
		frametext:SetText("    |cFFFFFFFF   KBs:\n" .. "|cffffcc00Active BG: ".. kbs_bg .."\n" .. "Session:     ".. kbs_session)
end)


